﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'version 1.00
#DesignerProperty: Key: MinValue, DisplayName: Min Value, FieldType: Float, DefaultValue: 0
#DesignerProperty: Key: MaxValue, DisplayName: Max Value, FieldType: Float, DefaultValue: 100
#DesignerProperty: Key: IndicatorLength, DisplayName: Indicator Length, FieldType: Int, DefaultValue: 40
#DesignerProperty: Key: CenterColor, DisplayName: Center Color, FieldType: Color, DefaultValue: 0xFF7C7C7C
#DesignerProperty: Key: IndicatorColor, DisplayName: Indicator Color, FieldType: Color, DefaultValue: 0xFF000000
#DesignerProperty: Key: PrefixText, DisplayName: Prefix Text, FieldType: String, DefaultValue: 
#DesignerProperty: Key: SuffixText, DisplayName: Suffix Text, FieldType: String, DefaultValue: °
#DesignerProperty: Key: Duration, DisplayName: Duration From 0 To 100, FieldType: Int, DefaultValue: 3000, Description: Milliseconds
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView
	Private xui As XUI
	Private cvsGauge, cvsIndicator As B4XCanvas
	Private mlbl As B4XView
	Type GaugeRange (LowValue As Float, HighValue As Float, Color As Int)
	Private mRanges As List
	Private GaugePanel, IndicatorPanel As B4XView
	Private Radius As Float
	Private IndicatorLength As Int
	Private CenterColor, IndicatorColor As Int
	Private MinValue, MaxValue As Float
	Private IndicatorBaseWidth As Float = 20dip
	Private mCurrentValue As Float = 50
	Private PrefixText, SuffixText As String
	Private DurationFromZeroTo100 As Int
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	mRanges.Initialize
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	IndicatorLength = DipToCurrent(Props.Get("IndicatorLength"))
	CenterColor = xui.PaintOrColorToColor(Props.Get("CenterColor"))
	IndicatorColor = xui.PaintOrColorToColor(Props.Get("IndicatorColor"))
	MinValue = Props.Get("MinValue")
	MaxValue = Props.Get("MaxValue")
	PrefixText = Props.Get("PrefixText")
	PrefixText = PrefixText.ToUpperCase 'there are only upper case characters in the font
	SuffixText = Props.Get("SuffixText")
	DurationFromZeroTo100 = Props.Get("Duration")
	mBase = Base
	Dim NativeFont As Object
#if B4J
	Dim fx As JFX
	NativeFont = fx.DefaultFont(20) 'fx.LoadFont(File.DirAssets, "Crysta.ttf", 20)
	Lbl.Style = ""
#else if B4A
	NativeFont = Typeface.LoadFromAssets("Crysta.ttf")
#else if B4i
	NativeFont = Font.CreateNew2("Crystal", 20)
#End If
	GaugePanel = xui.CreatePanel("")
	
	mBase.AddView(GaugePanel, 0, 0, mBase.Width, mBase.Height)
	cvsGauge.Initialize(GaugePanel)
	IndicatorPanel = xui.CreatePanel("")
	mBase.AddView(IndicatorPanel, 0, 0, mBase.Width, mBase.Height)
	cvsIndicator.Initialize(IndicatorPanel)
	mlbl = Lbl
	mlbl.Font = xui.CreateFont(NativeFont, 30)
	mlbl.SetTextAlignment("CENTER", "CENTER")
	mlbl.TextColor = xui.Color_Black
	Dim lblheight As Float
	If PrefixText.Contains(CRLF) Then lblheight = 65dip Else lblheight = 35dip
	mBase.AddView(mlbl, 0, 0, 0, lblheight) 'label size
	Base_Resize(mBase.Width, mBase.Height)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
 	mlbl.SetLayoutAnimated(0, 0, Height - mlbl.Height, Width, mlbl.Height)
	GaugePanel.SetLayoutAnimated(0, 0, 0, Width, Height)
	cvsGauge.Resize(Width, Height)
	IndicatorPanel.SetLayoutAnimated(0, 0, 0, Width, Height)
	cvsIndicator.Resize(Width, Height)
	Radius = Min(Width / 2, Height)
	DrawBackground
End Sub

Private Sub DrawBackground
	Dim x As Float = cvsGauge.TargetRect.CenterX
	Dim y As Float = cvsGauge.TargetRect.Height
	cvsGauge.ClearRect(cvsGauge.TargetRect)
	cvsGauge.DrawCircle(x, y, Radius, xui.Color_White, True, 0)
	For Each gr As GaugeRange In mRanges
		Dim p As B4XPath
		Dim StartAngle As Float = ValueToAngle(gr.LowValue)
		p.InitializeArc(x, y, Radius, StartAngle, ValueToAngle(gr.HighValue) - StartAngle)
		cvsGauge.ClipPath(p)
		cvsGauge.DrawCircle(x, y, Radius, gr.Color, True, 0)
		cvsGauge.RemoveClip
	Next
	cvsGauge.Invalidate
	DrawIndicator(mCurrentValue)
End Sub

Private Sub DrawIndicator (Value As Float)
	Dim x As Float = cvsIndicator.TargetRect.CenterX
	Dim y As Float = cvsIndicator.TargetRect.Height
	cvsIndicator.ClearRect(cvsIndicator.TargetRect)
	Dim angle As Float = ValueToAngle(Value)
	Dim p As B4XPath
	p.Initialize(x + IndicatorBaseWidth * SinD(angle), y - IndicatorBaseWidth * CosD(angle))
	Dim length As Float = Radius - 0.3 * IndicatorLength
	p.LineTo(x + length * CosD(angle), y + length * SinD(angle))
	p.LineTo(x - IndicatorBaseWidth * SinD(angle), y + IndicatorBaseWidth * CosD(angle))
	cvsIndicator.ClipPath(p)
	cvsIndicator.DrawRect(cvsIndicator.TargetRect, IndicatorColor, True, 0)
	cvsIndicator.RemoveClip
	cvsIndicator.DrawCircle(x, y, Radius - IndicatorLength, CenterColor, True, 0)
	cvsIndicator.Invalidate
	mlbl.Text = PrefixText & NumberFormat2(Value, 2, 1, 1, True) & SuffixText
End Sub

Private Sub ValueToAngle (Value As Float) As Float
	Return (Value - MinValue) / (MaxValue - MinValue) * 180 + 180
End Sub

Public Sub SetRanges(Ranges As List)
	mRanges = Ranges
	DrawBackground
End Sub

Public Sub CreateRange(LowValue As Float, HighValue As Float, Color As Int) As GaugeRange
	Dim r As GaugeRange
	r.Initialize
	r.LowValue = LowValue
	r.HighValue = HighValue
	r.Color = Color
	Return r
End Sub

Public Sub setCurrentValue (v As Float)
	Dim NewValue As Float = Min(MaxValue, Max(MinValue, v))
	AnimateValueTo(NewValue)
End Sub

Public Sub getCurrentValue As Float
	Return mCurrentValue
End Sub

Public Sub SetMinAndMax(NewMinValue As Float, NewMaxValue As Float)
	MinValue = NewMinValue
	MaxValue = NewMaxValue
	DrawBackground
	
End Sub

Private Sub AnimateValueTo(NewValue As Float)
	Dim n As Long = DateTime.Now
	Dim duration As Int = Abs(mCurrentValue - NewValue) / 100 * DurationFromZeroTo100 + 1000
	Dim start As Float = mCurrentValue
	mCurrentValue = NewValue
	Dim tempValue As Float
	Do While DateTime.Now < n + duration
		tempValue = ValueFromTimeEaseInOut(DateTime.Now - n, start, NewValue - start, duration)
		DrawIndicator(tempValue)
		Sleep(10)
		If NewValue <> mCurrentValue Then Return 'will happen if another update has started
	Loop
	DrawIndicator(mCurrentValue)
End Sub

'quartic easing in/out from http://gizma.com/easing/
Private Sub ValueFromTimeEaseInOut(Time As Float, Start As Float, ChangeInValue As Float, Duration As Int) As Float
	Time = Time / (Duration / 2)
	If Time < 1 Then
		Return ChangeInValue / 2 * Time * Time * Time * Time + Start
	Else
		Time = Time - 2
		Return -ChangeInValue / 2 * (Time * Time * Time * Time - 2) + Start
	End If
End Sub